CON     ''This CON block Initiallizes the Clock configuration for the Propeller     
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ     ''This OBJ block belongs to the Frequency Synthesizer
  Freq   : "Synth"  

CON     ''This CON block belongs to the Frequency Synthesizer

OutputFrequencyPin = 0

       Frequency_A = 1000
       Frequency_B = 1000

OBJ     ''This CON block belongs to the VGA graphics
  gr     : "VGA.graphics"

CON     ''This CON block belongs to the VGA graphics

'512x192
tiles = gr#tiles

PUB DEMO|i,FreqTest,X,Y,OldX,OldY,Scale,SpectralMAX

    Freq.Synth("A",OutputFrequencyPin, Frequency_A)     'Start Freqency Synthesizer for Frequency "A"
    'Freq.Synth("B",OutputFrequencyPin, Frequency_B)     'Start Freqency Synthesizer for Frequency "B"

    gr.start                                            'Start the VGA graphics driver
    repeat i from 0 to tiles - 1                        'init tile colors to Scope-Green on Black
      gr.color(i,$BB00)

    gr.clear
    gr.pointcolor(1)                                    'Turn drawing pen to color "1"
    gr.text(16,0,string("VGA Spectrum Analyzer"))       'Display some Text

    Scale := ((StopFrequency - StartFrequency)*1000)/{Screen Width ->}511       'Calculate Visual Scale
    SpectralMAX := Samples * 32                                                 'Calculate Maximum value ; 100% match

    repeat FreqTest from StartFrequency to StopFrequency step StepFrequency     'Do Frequency Scan 
       Detect(FreqTest)                                                         'Tune in and detect specified frequency 

       OldX := X                                                                'Do this so we can draw a line 
       OldY := Y                                                                'from point to point.
       
       X := ((FreqTest-StartFrequency) * 1000)/ Scale                           'calculate X position
       Y := (DataResult * 100)/ SpectralMAX                                     'calculate Y position
       
       gr.line(OldX, 200-OldY,X,200-Y)                                          'draw line from previous to current

    repeat                                                                      'keep COG alive

CON
{{
******************************************************************************************************************
******************************************************************************************************************
        Everything below this CON block is all you need for the Spectrum Analyzer Frequency Detection.
******************************************************************************************************************
******************************************************************************************************************
}}
CON

 InputPin = 0
  Samples = 5  'Each Sample contains 8-Periods


StartFrequency  = 500
StopFrequency = 1_400
StepFrequency   = 10

VAR

long    DataResult
 
PUB Detect(SpecificFrequency)|Status
    Status~                                             'clear status register                       
    _Status := @Status                                  'Store address of Status for Assembly routine
    cps := clkfreq/SpecificFrequency #> 40              'Calculate Clocks Per Sample                 
    cognew(@FrequencyDetect,@DataResult)                'Start a new instance of FastIO              
    repeat while Status == 0                            'Wait here until samples are complete
    
DAT
FrequencyDetect         org    0
              mov       temp, #1        wz      'Configure Pin as an Input
              shl       temp, InputPinMask
              mov       InputPinMask, temp
              muxz      dira, InputPinMask      'Set Pin to an INPUT

              mov       acc1, #0
              mov       acc2, #0

              shr       cps, #2

              mov       temp, cnt               'grab current counter value

NewSample     add       temp, cps
              add       temp, cps
              add       temp, cps
              add       temp, cps
'--------------------------------------------------------------------------------------------------- 1-Period
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 2-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 3-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 4-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 5-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 6-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 7-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'--------------------------------------------------------------------------------------------------- 8-Periods        
              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_c  add       acc1, #1
        if_nc sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag        
        if_c  add       acc2, #1
        if_nc sub       acc2, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc1, #1
        if_c  sub       acc1, #1

              waitcnt   temp, cps               'Wait for next time interval
              test      InputPinMask, ina wc    'Check I/O pin for a "1" or a "0" ; set "C" flag
        if_nc add       acc2, #1
        if_c  sub       acc2, #1
'------------------------------------------------------------------------------------------------
              djnz      DataSamples, #NewSample 'Get next sample

              abs       acc1, acc1
              abs       acc2, acc2

              add       acc1, acc2              

              wrlong    acc1, par               'Write the accumulator value to the Data pointer

              mov       temp, #1                'Update 'Status' register indicating that data is ready
              wrlong    temp, _Status

              cogid     temp                    
              cogstop   temp                    'STOP this COG

InputPinMask  long      InputPin
DataSamples   long      Samples
cps           long      0
_Status       long      0
acc1          long      0
acc2          long      0
temp          long      0